#
# Conditional build:
%bcond_without	initrd		# don't build initrd version
%bcond_with	dietlibc	# link initrd version with static glibc instead of dietlibc
%bcond_without	tests		# don't perform "make test"
#
Summary:	Tool for creating and maintaining software RAID devices
Summary(pl.UTF-8):	Narzędzie do tworzenia i obsługi programowych macierzy RAID
Name:		mdadm
Version:	3.3
Release:	1
License:	GPL v2+
Group:		Base
Source0:	https://www.kernel.org/pub/linux/utils/raid/mdadm/%{name}-%{version}.tar.xz
# Source0-md5:	abb19b309281b93cf79d29fb2dfb2e85
Source1:	%{name}.init
Source2:	%{name}.sysconfig
Source3:	%{name}.cron
Source4:	%{name}-checkarray
URL:		https://www.kernel.org/pub/linux/utils/raid/mdadm/
BuildRequires:	groff
BuildRequires:	rpmbuild(macros) >= 1.213
%if %{with initrd}
	%if %{with dietlibc}
BuildRequires:	dietlibc-static
	%else
BuildRequires:	glibc-static
	%endif
%endif
BuildRequires:	rpmbuild(macros) >= 1.268
BuildRequires:	tar >= 1:1.22
BuildRequires:	xz
Requires(post,preun):	/sbin/chkconfig
Requires:	/sbin/chkconfig
Requires:	rc-scripts >= 0.4.2.4-2
Obsoletes:	mdctl
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_sbindir		/sbin

%description
This package includes tool you need to set up and maintain a software
RAID device under Linux. It's thought as an alternative to raidtools
package.

%description -l pl.UTF-8
Pakiet ten zawiera narzędzie potrzebne do tworzenia i obsługi
programowych macierzy RAID. Program ten jest pomyślany jako
alternatywa dla pakietu raidtools.

%package initrd
Summary:	Tool for maintaining software RAID devices - initrd version
Summary(pl.UTF-8):	Narzędzie do obsługi programowych macierzy RAID, wersja dla initrd
Group:		Base
Conflicts:	geninitrd < 10000.10

%description initrd
Tool for maintaining software RAID devices - statically linked for
initrd.

%description initrd -l pl.UTF-8
Narzędzie do zarządzania programowymi macierzami RAID - statycznie
skonsolidowane na potrzeby initrd.

%prep
%setup -q

%build
%if %{with initrd}
%if %{with dietlibc}
%{__make} mdadm \
	CC="diet %{__cc} %{rpmcflags} %{rpmcppflags} %{rpmldflags} -Os -static" \
	CWFLAGS="-Wall"
mv -f mdadm initrd-mdadm
%{__make} clean
diet %{__cc} -DUCLIBC -DMDASSEMBLE_AUTO -DMDASSEMBLE %{rpmcflags} %{rpmcppflags} %{rpmldflags} -Os -static \
	-o initrd-mdassemble \
	mdassemble.c Assemble.c Manage.c config.c policy.c dlink.c util.c lib.c \
        super0.c super1.c super-ddf.c super-intel.c sha1.c crc32.c sg_io.c mdstat.c \
        platform-intel.c probe_roms.c sysfs.c super-mbr.c super-gpt.c mdopen.c maps.c xmalloc.c
%else
%{__make} mdadm.static \
	CC="%{__cc}" \
	CFLAGS="%{rpmcflags} %{rpmcppflags}" \
	LDFLAGS="%{rpmldflags}"
mv -f mdadm.static initrd-mdadm
%{__make} clean
%{__cc} -DMDASSEMBLE_AUTO -DMDASSEMBLE %{rpmcflags} %{rpmcppflags} %{rpmldflags} -DHAVE_STDINT_H -static \
	-o initrd-mdassemble \
	mdassemble.c Assemble.c Manage.c config.c policy.c dlink.c util.c lib.c \
        super0.c super1.c super-ddf.c super-intel.c sha1.c crc32.c sg_io.c mdstat.c \
        platform-intel.c probe_roms.c sysfs.c super-mbr.c super-gpt.c mdopen.c maps.c xmalloc.c
%endif
%{__make} clean
%endif

%{__make} all mdadm.8 \
	CC="%{__cc}" \
	CFLAGS="%{rpmcflags} %{rpmcppflags}" \
	LDFLAGS="%{rpmldflags}" \
	SYSCONFDIR="%{_sysconfdir}"

%{?with_tests:%{__make} test}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_sbindir},%{_mandir}/man{5,8},/etc/{rc.d/init.d,sysconfig,cron.d}}

%if %{with initrd}
install -d $RPM_BUILD_ROOT%{_libdir}/initrd
install initrd-mdadm $RPM_BUILD_ROOT%{_libdir}/initrd/mdadm
install initrd-mdassemble $RPM_BUILD_ROOT%{_libdir}/initrd/mdassemble
ln -s mdadm $RPM_BUILD_ROOT%{_libdir}/initrd/mdctl
%endif

install mdadm $RPM_BUILD_ROOT%{_sbindir}

install md*.5 $RPM_BUILD_ROOT%{_mandir}/man5
install md*.8 $RPM_BUILD_ROOT%{_mandir}/man8

install mdadm.conf-example $RPM_BUILD_ROOT%{_sysconfdir}/mdadm.conf

ln -s mdadm $RPM_BUILD_ROOT%{_sbindir}/mdctl

install %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/%{name}
install %{SOURCE2} $RPM_BUILD_ROOT/etc/sysconfig/%{name}

install %{SOURCE3} $RPM_BUILD_ROOT/etc/cron.d/mdadm-checkarray
install %{SOURCE4} $RPM_BUILD_ROOT%{_sbindir}/mdadm-checkarray

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add %{name}
%service mdadm restart "RAID monitoring"

%preun
if [ "$1" = "0" ]; then
	%service mdadm stop
	/sbin/chkconfig --del mdadm
fi

%files
%defattr(644,root,root,755)
%doc ANNOUNCE* ChangeLog TODO
%attr(755,root,root) %{_sbindir}/mdadm
%attr(755,root,root) %{_sbindir}/mdadm-checkarray
%attr(755,root,root) %{_sbindir}/mdctl
%attr(640,root,root) %config(noreplace,missingok) %verify(not md5 mtime size) %{_sysconfdir}/mdadm.conf
%{_mandir}/man5/mdadm.conf.5*
%{_mandir}/man8/mdadm.8*
%{_mandir}/man8/mdassemble.8*
%{_mandir}/man8/mdmon.8*
%attr(754,root,root) /etc/rc.d/init.d/%{name}
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/%{name}
%config(noreplace) %attr(640,root,root) /etc/cron.d/mdadm-checkarray

%if %{with initrd}
%files initrd
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/initrd/mdadm
%attr(755,root,root) %{_libdir}/initrd/mdassemble
%attr(755,root,root) %{_libdir}/initrd/mdctl
%endif
%changelog
* Tue Oct 08 2013 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/mdadm.git;a=log;h=master

* Tue Sep 10 2013 Jakub Bogusz <qboosh@pld-linux.org> 063f2ee
- updated to 3.3

* Thu Oct 25 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> f06941a
- up to 3.2.6

* Sun May 20 2012 Paweł Sikora <pluto@pld-linux.org> 32443f6
- updated to 3.2.5.

* Fri May 11 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> 92d7937
- up to 3.2.4; drop obsolete patches

* Sat Apr 28 2012 Jan Rękorajski <baggins@pld-linux.org> d70df71
- rel 4
- drop initramfs package, it was never properly tested, never really updated
  and initramfs-tools functionality is obsoleted by dracut

* Thu Mar 08 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> b8dae64
- rel 3; fix but when activating bitmap on array fails sometimes

* Thu Feb 16 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> e802c54
- rel 2; fix segv at assemble (sometimes only)

* Wed Dec 28 2011 Arkadiusz Miśkiewicz <arekm@maven.pl> 2da6dd4
- up to 3.2.3

* Mon Dec 19 2011 Arkadiusz Miśkiewicz <arekm@maven.pl> bba284b
- release 2

* Thu Dec 01 2011 Bartłomiej Zimoń <cactus@pld-linux.org> d987ba0
- set config and pidfile for systemd

* Sat Nov 26 2011 Arkadiusz Miśkiewicz <arekm@maven.pl> 6c35098
- mdadm.8 is back

* Wed Sep 07 2011 Jakub Bogusz <qboosh@pld-linux.org> 7245a17
- don't install ANNOUNCE-3.1.5 as man page

* Wed Aug 24 2011 Arkadiusz Miśkiewicz <arekm@maven.pl> cea19dd
- up to 3.2.2

* Wed Mar 30 2011 Arkadiusz Miśkiewicz <arekm@maven.pl> 567ec1b
- up to 3.2.1

* Thu Feb 17 2011 Arkadiusz Miśkiewicz <arekm@maven.pl> e7049f7
- rel 0.1

* Thu Feb 17 2011 Arkadiusz Miśkiewicz <arekm@maven.pl> ba2df06
- up to 3.2

* Sat Sep 04 2010 Arkadiusz Miśkiewicz <arekm@maven.pl> 6984bfe
- up to 3.1.4; patch merged

* Mon Aug 30 2010 Paweł Sikora <pluto@pld-linux.org> f405ae5
- patch0 fixed, relase 3.

* Mon Aug 30 2010 Paweł Sikora <pluto@pld-linux.org> 5308124
- fix copy-paste bug.

* Mon Aug 30 2010 Paweł Sikora <pluto@pld-linux.org> 029a9cd
- allow dev_open() to work on read-only /dev.
- release 2.

